/*

IFT1169 - Gestion de la mémoire - Exemple 03 -

09-décembre	- 2017 v1.04	M.Lokbani - GCC 7.2 avec -std=c++17
14-septembre	- 2016 v1.03	M.Lokbani - GCC 6.1.1 avec -std=c++11
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
09-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Les différences entre une chaîne de caractères et un tableau de caractères
        
    Voir notes de cours, 3.2:
    
*/

#include <iostream>
using namespace std;

int main() {

	char tab1[] = {'B', 'o', 'n', 'j', 'o', 'u', 'r', '\0'};
	char tab2[] = "Bonjour";

	char *s1 = "Bonjour"; // s1 pointe le caractere 'B'.
	char *s2 = "Bonjour"; // Fort probable que s2 pointe a la meme place

	*tab1 = 'Q' ; *tab2 = 'A' ;

	cout << tab1 << " " << tab2 << endl;
	*s1 = 'Q' ;
	*s2 = 'A' ; // Peut generer une erreur de « segmentation » au moment de l'execution.

	return 0;

}



/*

	Les 2 avertissements ne sont pas gratuits!

	>g++ -Wall -pedantic -Os -c 03mem.cpp -o 03mem.o

	03mem.cpp: In function ‘int main()’:
	03mem.cpp:38:13: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wpedantic]
		char *s1 = "Bonjour"; // s1 pointe le caractere 'B'.
			^~~~~~~~~
	03mem.cpp:39:13: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wpedantic]
		char *s2 = "Bonjour"; // Fort probable que s2 pointe a la meme place
			^~~~~~~~~

	>Exit code: 0

	Si on ne les corrige pas, le programme va planter à l'exécution.

	>03mem
		Qonjour Aonjour
		Segmentation fault
	
*/