/*

IFT1169 - Gestion de la mémoire - Exemple 11 -

09-décembre	- 2017 v1.01	M.Lokbani - GCC 7.2 avec -std=c++17
15-septembre	- 2016 v1.00	M.Lokbani - GCC 6.1.1 avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Duree d'une vie dynamique
        
    Voir notes de cours, 5.4
    
*/

#include <iostream>
#include <cstdlib>
#include <string.h>
#include <unistd.h> 

int main (int argc, char **argv) {

	// alloue de la mémoire!
	// 27Go d'un coup, ouach!
	
	// long long pour éviter l'avertissement de débordement
	unsigned long long valeur = 28991029248;

	// 7.2, avertissement "-Walloc-size-larger-than=", on aura tout de suite une exception bad_alloc sous Windows
	
	char *p = new char [valeur];

	// initialise le bloc mémoire alloué avec des zéros, nécessaire pour enclencher l'allocation proprement dite
	// memset(p,0, valeur * sizeof (char));
	// à la sauce C++
	
	std::fill(p,p+(valeur*sizeof(char)),0);

	// s'en dormir le temps de voir la pagaille!
	// sous Linux free -h
	// arreter vite le programme avant que votre systeme
	// plante par manque de memoire!

	sleep (20);
	
	return 0;
}