/*

IFT1169 - Gestion de la mémoire - Exemple 13 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
09-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Utilisation de l'opérateur "new" avec un nothrow
        
    Voir notes de cours, 5.1:
    
    On constate dans cet exemple que l'opérateur new avec l<option "nothrow" ne lève
    aucune exception. Dans ce cas, il faudra prévoir un test de sortie pour éviter que
    votre machine se retrouve sans les ressources nécessaires pour son bon fonctionnement.
    
    Le test (p == 0) prend les choses en main, alors que l'exception bad_alloc ne sert à rien
    dans ce cas de figure.
    
*/


#include <iostream>
#include <string>
#include <cstdlib>

using namespace std;

void f(int size) {
    char *p = new (nothrow) char [size];
    if (p == 0){
        cout << "Plus de mémoire libre!"<<endl;
	exit (EXIT_FAILURE);
    }
    return;
}

const int BUF_SIZE = 999999999;

int main(){
    
	int *pn = new int;                // un seul entier
	*pn = 10;
	int *pi = new int(5);             // un seul entier, valeur 5
	double *pd = new double(55.9);   // un double, valeur 55.9
	int *buf = new int[10];           // pointeur sur 10 entiers

	// Affichage de quelques éléments pour éviter les avertissements
	cout << "pn: " << *pn << " ; pi: " << *pi << " ; pd: " << *pd << " ; buf[0]: " << buf[0] << endl;

	for (int i=0;;i++){
		cout << "i: " << i << endl;
		try {
			f(BUF_SIZE);
		}catch( bad_alloc &ba) {
			cout << ba.what( ) << endl;
			exit (EXIT_FAILURE);
		}
	}

	return 0;
}

/*

	Le programme peut planter plus tôt ou plus tard en fonction de la quantité mémoire dont dispose votre machine.

	>06amem
		pn: 10 ; pi: 5 ; pd: 55.9 ; buf[0]: 5374296
		i: 0
		i: 1
		i: 2
		i: 3
		i: 4
		i: 5
		i: 6
		i: 7
		i: 8
		i: 9
		i: 10
		i: 11
		i: 12
		i: 13
		i: 14
		i: 15
		i: 16
		i: 17
		i: 18
		i: 19
		i: 20
		i: 21
		i: 22
		i: 23
		i: 24
		i: 25
		i: 26
		i: 27
		i: 28
		i: 29
		i: 30
		i: 31
		Plus de mémoire libre!
	>Exit code: 1


*/
