/*

IFT1169 - Gestion de la mémoire - Exemple 15 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
09-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Les questions de placement - version rapide! - 
        
    Voir notes de cours, 5.3:
    
    Ici on uitlise l'opérateur new avec placement.
    
    
*/

#include <iostream>
#include <ctime>

class Test {};

using namespace std;

int main() {

    clock_t start, finish;
    start = clock();

    char *cp = new char[sizeof(Test)];

    for( long i = 0; i < 10000; ++i) {
        for ( long j = 0; j < 10000; ++j) {
            Test *dp = new(cp) Test();
            // ...
            dp->~Test();
        }
    }
    delete [] cp;
    
    finish = clock();
    cout << "Time : "
         << ((double)(finish - start))/CLOCKS_PER_SEC << endl;
    

    return 0;
}

/*

	Le résultat est fonction de la puissance de votre machine.
	Essayer de faire rouler les exemples 07mem et 08mem sur la même machine,
	pour mieux apprécier la différence et ce que le new avec placement apporte
	comme améliorations.


	>08mems
		Time : 0.312
	>Exit code: 0

*/

