/*

IFT1169 - Gestion de la mémoire - Exemple 16 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
16-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.



contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Surdéfinition des opérateurs new et delete au niveau global
        
    Voir notes de cours, 5.5:
    

*/

#include <iostream>
#include <new>
#include <cstdlib>

using namespace std;

void* operator new(size_t sz){
	cout << "Mon new!"<< endl;
	return malloc(sz);
}

void f(int size) {
	char *p = new char [size];
	if (p == 0){
		cout << "Plus de mémoire libre!"<<endl;
		std::bad_alloc exception;
		throw exception;
	}
	return;
}

const int BUF_SIZE = 999999999;

int main(){
    
	int *pn = new int;                // un seul entier
	*pn = 10;
	int *pi = new int(5);             // un seul entier, valeur 5
	double *pd = new double(55.9);   // un double, valeur 55.9
	int *buf = new int[10];           // pointeur sur 10 entiers

	// Affichage de quelques éléments pour éviter les avertissements
	cout << "pn: " << *pn << " ; pi: " << *pi << " ; pd: " << *pd << " ; buf[0]: " << buf[0] << endl;

	for (int i=0;i<500000;i++){
		cout << "i: " << i << endl;
		try {
			f(BUF_SIZE);
		}catch( bad_alloc &ba) {
			cout << ba.what( ) << endl;
			exit (EXIT_FAILURE);
		}
	}

	return 0;
}


/*

	>09mem
		Mon new!
		Mon new!
		Mon new!
		Mon new!
		pn: 10 ; pi: 5 ; pd: 55.9 ; buf[0]: 4026208
		i: 0
		Mon new!
		i: 1
		Mon new!
		i: 2
		Mon new!
		i: 3
		Mon new!
		i: 4
		Mon new!
		i: 5
		Mon new!
		i: 6
		Mon new!
		i: 7
		Mon new!
		i: 8
		Mon new!
		i: 9
		Mon new!
		i: 10
		Mon new!
		i: 11
		Mon new!
		i: 12
		Mon new!
		i: 13
		Mon new!
		i: 14
		Mon new!
		i: 15
		Mon new!
		i: 16
		Mon new!
		i: 17
		Mon new!
		i: 18
		Mon new!
		i: 19
		Mon new!
		i: 20
		Mon new!
		i: 21
		Mon new!
		i: 22
		Mon new!
		i: 23
		Mon new!
		i: 24
		Mon new!
		i: 25
		Mon new!
		i: 26
		Mon new!
		i: 27
		Mon new!
		i: 28
		Mon new!
		i: 29
		Mon new!
		i: 30
		Mon new!
		i: 31
		Mon new!
		Plus de mémoire libre!
		std::bad_alloc
	>Exit code: 1


*/