/*

IFT1169 - Gestion de la mémoire - Exemple 17 -

09-décembre	- 2017 v1.03	M.Lokbani - GCC 7.2 avec -std=c++17
09-mars			- 2015 v1.02	M.Lokbani - GCC 4.9.2  avec -std=c++11
16-novembre	- 2013 v1.01	M.Lokbani - GCC 4.8.1  avec -std=c++11
18-novembre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.



contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2017 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------

    Gestion de la mémoire
    
        Surdéfinition des opérateurs new[] et delete[] (pour un tableau) au niveau global
        
    Voir notes de cours, 5.5:
    
*/


#include <cstddef>
#include <stdio.h>
#include <iostream>

using namespace std;

class A {
	int x;
public:
	A() {
		cout << "A::A " << this << endl;
	}
	~A() {
		cout << "A::~A " << this << endl;
	}
};

void* operator new[](size_t sz) {
	cout << "allocation d'une taille de " << sz << endl;

	void* vp = operator new(sz);

	if (vp == 0){
		cout << "Plus de mémoire libre!"<<endl;
		std::bad_alloc exception;
		throw exception;
	}

	cout << "allocation d'un pointeur " << vp << endl;

	return vp;
}

void operator delete[](void* ptr) throw() {
	cout << "pointeur retourne = " << ptr << endl ;
	operator delete(ptr);
}

int main() {
	
	try {
		A* ap = new A[10];
		delete [] ap;
	}catch( bad_alloc &ba) {
		cout << ba.what( ) << endl;
		exit (EXIT_FAILURE);
	}

    
    return 0;
}

/*
	>10mem
		allocation d'une taille de 48
		allocation d'un pointeur 0x655590
		A::A 0x655598
		A::A 0x65559c
		A::A 0x6555a0
		A::A 0x6555a4
		A::A 0x6555a8
		A::A 0x6555ac
		A::A 0x6555b0
		A::A 0x6555b4
		A::A 0x6555b8
		A::A 0x6555bc
		A::~A 0x6555bc
		A::~A 0x6555b8
		A::~A 0x6555b4
		A::~A 0x6555b0
		A::~A 0x6555ac
		A::~A 0x6555a8
		A::~A 0x6555a4
		A::~A 0x6555a0
		A::~A 0x65559c
		A::~A 0x655598
		pointeur retourne = 0x655590
	>Exit code: 0
*/
